diff --git a/build/pymake/pymake/util.py b/build/pymake/pymake/util.py
index c63f930cc2..d3f193e54a 100644
--- a/build/pymake/pymake/util.py
+++ b/build/pymake/pymake/util.py
@@ -8,9 +8,9 @@ class MakeError(Exception):
     def __str__(self):
         locstr = ''
         if self.loc is not None:
-            locstr = "%s:" % (self.loc,)
+            locstr = "{}:".format(self.loc)
 
-        return "%s%s" % (locstr, self.msg)
+        return "{}{}".format(locstr, self.msg)
 
 def normaljoin(path, suffix):
     """
@@ -82,7 +82,7 @@ else:
         return str[:offset], token, str[offset + len(token):]
 
 try:
-    from __builtin__ import any
+    from builtins import any
 except ImportError:
     def any(it):
         for i in it:
@@ -90,7 +90,7 @@ except ImportError:
                 return True
         return False
 
-class _MostUsedItem(object):
+class _MostUsedItem:
     __slots__ = ('key', 'o', 'count')
 
     def __init__(self, key):
@@ -101,7 +101,7 @@ class _MostUsedItem(object):
     def __repr__(self):
         return "MostUsedItem(key=%r, count=%i, o=%r)" % (self.key, self.count, self.o)
 
-class MostUsedCache(object):
+class MostUsedCache:
     def __init__(self, capacity, creationfunc, verifyfunc):
         self.capacity = capacity
         self.cfunc = creationfunc
@@ -138,7 +138,7 @@ class MostUsedCache(object):
         return item.o
 
     def verify(self):
-        for k, v in self.d.iteritems():
+        for k, v in self.d.items():
             if v.o:
                 assert v in self.active
             else:
diff --git a/build/pymake/tests/datatests.py b/build/pymake/tests/datatests.py
index 513028b0b2..f42efbf6ee 100644
--- a/build/pymake/tests/datatests.py
+++ b/build/pymake/tests/datatests.py
@@ -4,7 +4,7 @@ import re
 from cStringIO import StringIO
 
 def multitest(cls):
-    for name in cls.testdata.iterkeys():
+    for name in cls.testdata.keys():
         def m(self, name=name):
             return self.runSingle(*self.testdata[name])
 
@@ -20,7 +20,7 @@ class SplitWordsTest(unittest.TestCase):
     def runTest(self):
         for s, e in self.testdata:
             w = s.split()
-            self.assertEqual(w, e, 'splitwords(%r)' % (s,))
+            self.assertEqual(w, e, 'splitwords({!r})'.format(s))
 
 class GetPatSubstTest(unittest.TestCase):
     testdata = (
@@ -37,9 +37,9 @@ class GetPatSubstTest(unittest.TestCase):
         for s, r, d, e in self.testdata:
             words = d.split()
             p = pymake.data.Pattern(s)
-            a = ' '.join((p.subst(r, word, False)
-                          for word in words))
-            self.assertEqual(a, e, 'Pattern(%r).subst(%r, %r)' % (s, r, d))
+            a = ' '.join(p.subst(r, word, False)
+                          for word in words)
+            self.assertEqual(a, e, 'Pattern({!r}).subst({!r}, {!r})'.format(s, r, d))
 
 class LRUTest(unittest.TestCase):
     # getkey, expected, funccount, debugitems
@@ -63,7 +63,7 @@ class LRUTest(unittest.TestCase):
         c = pymake.util.LRUCache(3, self.spaceFunc, lambda k, v: k % 2)
         self.assertEqual(tuple(c.debugitems()), ())
 
-        for i in xrange(0, len(self.expected)):
+        for i in range(0, len(self.expected)):
             k, e, fc, di = self.expected[i]
 
             v = c.get(k)
diff --git a/build/pymake/tests/formattingtests.py b/build/pymake/tests/formattingtests.py
index 7aad6d4cc1..2ab203a9ae 100644
--- a/build/pymake/tests/formattingtests.py
+++ b/build/pymake/tests/formattingtests.py
@@ -94,7 +94,7 @@ class StringExpansionTest(TestBase):
 
         e = StringExpansion('this is # not a comment', None)
         self.assertEqual(e.to_source(escape_comments=True),
-                         'this is \# not a comment')
+                         r'this is \# not a comment')
 
     def test_empty(self):
         e = StringExpansion('', None)
@@ -253,7 +253,7 @@ class MakefileCorupusTest(TestBase):
                 continue
 
             source = None
-            with open(makefile, 'rU') as fh:
+            with open(makefile) as fh:
                 source = fh.read()
 
             try:
@@ -277,7 +277,7 @@ class MakefileCorupusTest(TestBase):
 
             self.assertEqual(len(statements), len(new_statements))
 
-            for i in xrange(0, len(statements)):
+            for i in range(0, len(statements)):
                 original = statements[i]
                 formatted = new_statements[i]
 
diff --git a/build/pymake/tests/parsertests.py b/build/pymake/tests/parsertests.py
index ab6406be0f..0f6487fe5a 100644
--- a/build/pymake/tests/parsertests.py
+++ b/build/pymake/tests/parsertests.py
@@ -5,7 +5,7 @@ import logging
 from cStringIO import StringIO
 
 def multitest(cls):
-    for name in cls.testdata.iterkeys():
+    for name in cls.testdata.keys():
         def m(self, name=name):
             return self.runSingle(*self.testdata[name])
 
@@ -15,7 +15,7 @@ def multitest(cls):
 class TestBase(unittest.TestCase):
     def assertEqual(self, a, b, msg=""):
         """Actually print the values which weren't equal, if things don't work out!"""
-        unittest.TestCase.assertEqual(self, a, b, "%s got %r expected %r" % (msg, a, b))
+        unittest.TestCase.assertEqual(self, a, b, "{} got {!r} expected {!r}".format(msg, a, b))
 
 class DataTest(TestBase):
     testdata = {
@@ -86,7 +86,7 @@ class IterTest(TestBase):
             ),
         'makeescapedcomment': (
             pymake.parser.itermakefilechars,
-            "VAR = val \# escaped hash",
+            r"VAR = val \# escaped hash",
             "VAR = val # escaped hash"
             ),
         'makeescapedslash': (
@@ -116,8 +116,8 @@ class IterTest(TestBase):
             ),
         'commandcomment': (
             pymake.parser.itercommandchars,
-            "echo boo \# comment",
-            "echo boo \# comment",
+            r"echo boo \# comment",
+            r"echo boo \# comment",
             ),
         'commandcontinue': (
             pymake.parser.itercommandchars,
@@ -134,7 +134,7 @@ class IterTest(TestBase):
         self.assertEqual(actual, expected)
 
         if ifunc == pymake.parser.itermakefilechars:
-            print "testing %r" % expected
+            print("testing %r" % expected)
             self.assertEqual(pymake.parser.flattenmakesyntax(d, 0), expected)
 
 multitest(IterTest)
@@ -206,18 +206,18 @@ class MakeSyntaxTest(TestBase):
 
     def compareRecursive(self, actual, expected, path):
         self.assertEqual(len(actual), len(expected),
-                         "compareRecursive: %s %r" % (path, actual))
-        for i in xrange(0, len(actual)):
+                         "compareRecursive: {} {!r}".format(path, actual))
+        for i in range(0, len(actual)):
             ipath = path + [i]
 
             a, isfunc = actual[i]
             e = expected[i]
             if isinstance(e, str):
-                self.assertEqual(a, e, "compareRecursive: %s" % (ipath,))
+                self.assertEqual(a, e, "compareRecursive: {}".format(ipath))
             else:
                 self.assertEqual(type(a), getattr(pymake.functions, e['type']),
-                                 "compareRecursive: %s" % (ipath,))
-                for k, v in e.iteritems():
+                                 "compareRecursive: {}".format(ipath))
+                for k, v in e.items():
                     if k == 'type':
                         pass
                     elif k[0] == '[':
@@ -229,7 +229,7 @@ class MakeSyntaxTest(TestBase):
                         proppath = ipath + [item]
                         self.compareRecursive(getattr(a, item), v, proppath)
                     else:
-                        raise Exception("Unexpected property at %s: %s" % (ipath, k))
+                        raise Exception("Unexpected property at {}: {}".format(ipath, k))
 
     def runSingle(self, s, startat, stopat, stopoffset, expansion):
         d = pymake.parser.Data.fromstring(s, pymake.parserdata.Location('testdata', 1, 0))
@@ -264,7 +264,7 @@ class VariableTest(TestBase):
 
         m = pymake.data.Makefile()
         stmts.execute(m)
-        for k, v in self.expected.iteritems():
+        for k, v in self.expected.items():
             flavor, source, val = m.variables.get(k)
             if val is None:
                 self.assertEqual(val, v, 'variable named %s' % k)
diff --git a/build/pymake/tests/runtests.py b/build/pymake/tests/runtests.py
index ab149ecfb1..6ea0b91a97 100644
--- a/build/pymake/tests/runtests.py
+++ b/build/pymake/tests/runtests.py
@@ -78,15 +78,15 @@ def runTest(makefile, make, logfile, options):
     logfd.close()
 
     if stdout.find('TEST-FAIL') != -1:
-        print stdout
+        print(stdout)
         return False, "FAIL (TEST-FAIL printed)"
 
     if options['grepfor'] and stdout.find(options['grepfor']) == -1:
-        print stdout
+        print(stdout)
         return False, "FAIL (%s not in output)" % options['grepfor']
 
     if options['returncode'] == 0 and stdout.find('TEST-PASS') == -1:
-        print stdout
+        print(stdout)
         return False, 'FAIL (No TEST-PASS printed)'
 
     if options['returncode'] != 0:
@@ -94,7 +94,7 @@ def runTest(makefile, make, logfile, options):
 
     return True, 'PASS'
 
-print "%-30s%-28s%-28s" % ("Test:", "gmake:", "pymake:")
+print("%-30s%-28s%-28s" % ("Test:", "gmake:", "pymake:"))
 
 gmakefails = 0
 pymakefails = 0
@@ -153,7 +153,7 @@ for makefile in makefiles:
         elif key == 'skip':
             d['skip'] = True
         else:
-            print >>sys.stderr, "%s: Unexpected #T key: %s" % (makefile, key)
+            print("%s: Unexpected #T key: %s" % (makefile, key), file=sys.stderr)
             sys.exit(1)
 
     mdata.close()
@@ -190,12 +190,11 @@ for makefile in makefiles:
         else:
             pymakemsg = "OK (known fail)"
 
-    print "%-30.30s%-28.28s%-28.28s" % (os.path.basename(makefile),
+    print("%-30.30s%-28.28s%-28.28s" % (os.path.basename(makefile),)
                                         gmakemsg, pymakemsg)
 
-print
-print "Summary:"
-print "%-30s%-28s%-28s" % ("", "gmake:", "pymake:")
+print(print "Summary:")
+print("%-30s%-28s%-28s" % ("", "gmake:", "pymake:"))
 
 if gmakefails == 0:
     gmakemsg = 'PASS'
@@ -207,7 +206,7 @@ if pymakefails == 0:
 else:
     pymakemsg = 'FAIL (%i failures)' % pymakefails
 
-print "%-30.30s%-28.28s%-28.28s" % ('', gmakemsg, pymakemsg)
+print("%-30.30s%-28.28s%-28.28s" % ('', gmakemsg, pymakemsg))
 
 shutil.rmtree(opts.tempdir)
 
diff --git a/build/release/info.py b/build/release/info.py
index 7e7a30bcea..c3c3ec9921 100644
--- a/build/release/info.py
+++ b/build/release/info.py
@@ -4,7 +4,7 @@ from os import path
 import re
 import shutil
 import sys
-from urllib2 import urlopen
+from urllib.request import urlopen
 
 from release.paths import makeCandidatesDir
 
@@ -13,7 +13,7 @@ log = logging.getLogger(__name__)
 
 # If version has two parts with no trailing specifiers like "rc", we
 # consider it a "final" release for which we only create a _RELEASE tag.
-FINAL_RELEASE_REGEX = "^\d+\.\d+$"
+FINAL_RELEASE_REGEX = r"^\d+\.\d+$"
 
 
 class ConfigError(Exception):
@@ -50,7 +50,7 @@ def findOldBuildIDs(product, version, buildNumber, platforms,
                 id = getBuildID(platform, product, version, n, nightlyDir,
                                 server)
                 ids[platform].append(id)
-            except Exception, e:
+            except Exception as e:
                 log.error("Hit exception: %s" % e)
     return ids
 
@@ -62,7 +62,7 @@ def getReleaseConfigName(product, branch, version=None, staging=False):
     if product == 'thunderbird' and 'esr17' in branch and version and 'esr' not in version:
         cfg = 'release-thunderbird-comm-release.py'
     else:
-        cfg = 'release-%s-%s.py' % (product, branch)
+        cfg = 'release-{}-{}.py'.format(product, branch)
     if staging:
         cfg = 'staging_%s' % cfg
     return cfg
@@ -87,15 +87,15 @@ def readBranchConfig(dir, localconfig, branch, required=[]):
 
 def readConfig(configfile, keys=[], required=[]):
     c = {}
-    execfile(configfile, c)
+    exec(compile(open(configfile, "rb").read(), configfile, 'exec'), c)
     for k in keys:
         c = c[k]
-    items = c.keys()
+    items = list(c.keys())
     err = False
     for key in required:
         if key not in items:
             err = True
-            log.error("Required item `%s' missing from %s" % (key, c))
+            log.error("Required item `{}' missing from {}".format(key, c))
     if err:
         raise ConfigError("Missing at least one item in config, see above")
     return c
@@ -108,7 +108,7 @@ def isFinalRelease(version):
 def getBaseTag(product, version):
     product = product.upper()
     version = version.replace('.', '_')
-    return '%s_%s' % (product, version)
+    return '{}_{}'.format(product, version)
 
 
 def getTags(baseTag, buildNumber, buildTag=True):
@@ -127,13 +127,13 @@ def getReleaseTag(tag):
 
 
 def generateRelbranchName(version, prefix='GECKO'):
-    return '%s%s_%s_RELBRANCH' % (
+    return '{}{}_{}_RELBRANCH'.format(
         prefix, version.replace('.', ''),
         datetime.utcnow().strftime('%Y%m%d%H'))
 
 
 def getReleaseName(product, version, buildNumber):
-    return '%s-%s-build%s' % (product.title(), version, str(buildNumber))
+    return '{}-{}-build{}'.format(product.title(), version, str(buildNumber))
 
 
 def getRepoMatchingBranch(branch, sourceRepositories):
@@ -161,7 +161,7 @@ def fileInfo(filepath, product):
         # Mozilla 1.9.0 style (aka 'short') paths
         # e.g. firefox-3.0.12.en-US.win32.complete.mar
         filename = os.path.basename(filepath)
-        m = re.match("^(%s)-([0-9.]+)\.([-a-zA-Z]+)\.(win32)\.(complete|installer)\.(mar|exe)$" % product, filename)
+        m = re.match(r"^(%s)-([0-9.]+)\.([-a-zA-Z]+)\.(win32)\.(complete|installer)\.(mar|exe)$" % product, filename)
         if not m:
             raise ValueError("Could not parse: %s" % filename)
         return {'product': m.group(1),
@@ -180,7 +180,7 @@ def fileInfo(filepath, product):
         ret = {'pathstyle': 'long'}
         if filepath.endswith('.mar'):
             ret['format'] = 'mar'
-            m = re.search("update/(win32|linux-i686|linux-x86_64|mac|mac64)/([-a-zA-Z]+)/(%s)-(\d+\.\d+(?:\.\d+)?(?:\w+(?:\d+)?)?)\.(complete)\.mar" % product, filepath)
+            m = re.search(r"update/(win32|linux-i686|linux-x86_64|mac|mac64)/([-a-zA-Z]+)/(%s)-(\d+\.\d+(?:\.\d+)?(?:\w+(?:\d+)?)?)\.(complete)\.mar" % product, filepath)
             if not m:
                 raise ValueError("Could not parse: %s" % filepath)
             ret['platform'] = m.group(1)
@@ -196,7 +196,7 @@ def fileInfo(filepath, product):
             # that we can't catch them in the same regexp
             if filepath.find('win32-EUballot') != -1:
                 ret['platform'] = 'win32'
-                m = re.search("(win32-EUballot/)([-a-zA-Z]+)/((?i)%s) Setup (\d+\.\d+(?:\.\d+)?(?:\w+\d+)?(?:\ \w+\ \d+)?)\.exe" % product, filepath)
+                m = re.search(r"(win32-EUballot/)([-a-zA-Z]+)/((?i)%s) Setup (\d+\.\d+(?:\.\d+)?(?:\w+\d+)?(?:\ \w+\ \d+)?)\.exe" % product, filepath)
                 if not m:
                     raise ValueError("Could not parse: %s" % filepath)
                 ret['leading_path'] = m.group(1)
@@ -204,7 +204,7 @@ def fileInfo(filepath, product):
                 ret['product'] = m.group(3).lower()
                 ret['version'] = m.group(4)
             else:
-                m = re.search("(partner-repacks/[-a-zA-Z0-9_]+/|)(win32|mac|linux-i686)/([-a-zA-Z]+)/((?i)%s) Setup (\d+\.\d+(?:\.\d+)?(?:\w+(?:\d+)?)?(?:\ \w+\ \d+)?)\.exe" % product, filepath)
+                m = re.search(r"(partner-repacks/[-a-zA-Z0-9_]+/|)(win32|mac|linux-i686)/([-a-zA-Z]+)/((?i)%s) Setup (\d+\.\d+(?:\.\d+)?(?:\w+(?:\d+)?)?(?:\ \w+\ \d+)?)\.exe" % product, filepath)
                 if not m:
                     raise ValueError("Could not parse: %s" % filepath)
                 ret['leading_path'] = m.group(1)
diff --git a/build/release/sanity.py b/build/release/sanity.py
index aba8559894..70d745f471 100644
--- a/build/release/sanity.py
+++ b/build/release/sanity.py
@@ -1,10 +1,11 @@
 import difflib
 import logging
 import re
-import urllib2
+import six.moves.urllib.request, six.moves.urllib.error, six.moves.urllib.parse
 from util.commands import run_cmd, get_output
 from util.hg import get_repo_name, make_hg_url
 from subprocess import CalledProcessError
+import six
 
 log = logging.getLogger(__name__)
 
@@ -44,7 +45,7 @@ def get_buildbot_username_param():
 
 def sendchange(branch, revision, username, master, products):
     """Send the change to buildbot to kick off the release automation"""
-    if isinstance(products, basestring):
+    if isinstance(products, str):
         products = [products]
     cmd = [
         'buildbot',
@@ -107,7 +108,7 @@ def verify_mozconfigs(mozconfig_pair, nightly_mozconfig_pair, platform,
                             mozconfigWhitelist['nightly'][platform]:
                         continue
                     else:
-                        log.warning("%s not in %s %s!" % (
+                        log.warning("{} not in {} {}!".format(
                             clean_line, platform,
                             mozconfigWhitelist['nightly'][platform]))
             else:
diff --git a/build/subconfigure.py b/build/subconfigure.py
index 6c152f4065..4e54a9a268 100644
--- a/build/subconfigure.py
+++ b/build/subconfigure.py
@@ -131,11 +131,11 @@ def maybe_clear_cache(data):
         is_set = cache.get('ac_cv_env_%s_set' % precious) == 'set'
         value = cache.get('ac_cv_env_%s_value' % precious) if is_set else None
         if value != env.get(precious):
-            print 'Removing %s because of %s value change from:' \
-                % (data['cache-file'], precious)
-            print '  %s' % (value if value is not None else 'undefined')
-            print 'to:'
-            print '  %s' % env.get(precious, 'undefined')
+            print('Removing %s because of %s value change from:'
+                  % (data['cache-file'], precious))
+            print('  %s' % (value if value is not None else 'undefined'))
+            print('to:')
+            print('  %s' % env.get(precious, 'undefined'))
             os.remove(data['cache-file'])
             return True
     return False
@@ -199,9 +199,12 @@ def prepare(srcdir, objdir, shell, args):
     data_file = os.path.join(objdir, CONFIGURE_DATA)
     previous_args = None
     if os.path.exists(data_file):
-        with open(data_file, 'rb') as f:
-            data = pickle.load(f)
-            previous_args = data['args']
+        try:
+            with open(data_file, 'rb') as f:
+                data = pickle.load(f)
+                previous_args = data['args']
+        except (EOFError, pickle.UnpicklingError):
+            pass
 
     # Msys likes to break environment variables and command line arguments,
     # so read those from stdin, as they are passed from the configure script
@@ -221,7 +224,7 @@ def prepare(srcdir, objdir, shell, args):
                 environ[var] = os.environ[var]
         args = data['args']
     else:
-        environ = os.environ
+        environ = dict(os.environ)
 
     args, others = parser.parse_known_args(args)
 
@@ -333,14 +336,20 @@ def run(objdir):
         # We're going to run it ourselves.
         command += ['--no-create']
 
-        print prefix_lines('configuring', relobjdir)
-        print prefix_lines('running %s' % ' '.join(command[:-1]), relobjdir)
+        print(prefix_lines('configuring', relobjdir))
+        print(prefix_lines('running %s' % ' '.join(command[:-1]), relobjdir))
         sys.stdout.flush()
         try:
-            output += subprocess.check_output(command,
+            cmd_out = subprocess.check_output(command,
                 stderr=subprocess.STDOUT, cwd=objdir, env=data['env'])
+            if isinstance(cmd_out, bytes):
+                cmd_out = cmd_out.decode('utf-8', errors='replace')
+            output += cmd_out
         except subprocess.CalledProcessError as e:
-            return relobjdir, e.returncode, e.output
+            err_out = e.output
+            if isinstance(err_out, bytes):
+                err_out = err_out.decode('utf-8', errors='replace')
+            return relobjdir, e.returncode, err_out
 
         # Leave config.status with a new timestamp if configure is newer than
         # its original mtime.
@@ -368,15 +377,21 @@ def run(objdir):
 
     if not skip_config_status:
         if skip_configure:
-            print prefix_lines('running config.status', relobjdir)
+            print(prefix_lines('running config.status', relobjdir))
             sys.stdout.flush()
         try:
-            output += subprocess.check_output([data['shell'], '-c',
+            cs_out = subprocess.check_output([data['shell'], '-c',
                 './config.status'], stderr=subprocess.STDOUT, cwd=objdir,
                 env=data['env'])
+            if isinstance(cs_out, bytes):
+                cs_out = cs_out.decode('utf-8', errors='replace')
+            output += cs_out
         except subprocess.CalledProcessError as e:
             ret = e.returncode
-            output += e.output
+            err_out2 = e.output
+            if isinstance(err_out2, bytes):
+                err_out2 = err_out2.decode('utf-8', errors='replace')
+            output += err_out2
 
         for f in contents:
             f.update_time()
@@ -395,9 +410,9 @@ def subconfigure(args):
     args, others = parser.parse_known_args(args)
     subconfigures = args.subconfigures
     if args.list:
-        subconfigures.extend(open(args.list, 'rb').read().splitlines())
+        subconfigures.extend(open(args.list, 'r').read().splitlines())
     if args.skip:
-        skips = set(open(args.skip, 'rb').read().splitlines())
+        skips = set(open(args.skip, 'r').read().splitlines())
         subconfigures = [s for s in subconfigures if s not in skips]
 
     if not subconfigures:
@@ -410,7 +425,7 @@ def subconfigure(args):
     pool = Pool(len(subconfigures))
     for relobjdir, returncode, output in \
             pool.imap_unordered(run, subconfigures):
-        print prefix_lines(output, relobjdir)
+        print(prefix_lines(output, relobjdir))
         sys.stdout.flush()
         ret = max(returncode, ret)
         if ret:
diff --git a/build/submit_telemetry_data.py b/build/submit_telemetry_data.py
index 918d840b7b..58c6d203fa 100644
--- a/build/submit_telemetry_data.py
+++ b/build/submit_telemetry_data.py
@@ -36,7 +36,7 @@ def submit_telemetry_data(statedir):
         path = os.path.join(outgoing, filename)
         if os.path.isdir(path) or not path.endswith('.json'):
             continue
-        with open(path, 'r') as f:
+        with open(path) as f:
             data = f.read()
             try:
                 r = session.post(BUILD_TELEMETRY_SERVER, data=data,
diff --git a/build/upload.py b/build/upload.py
index c6bc10429b..7b9d4d7745 100644
--- a/build/upload.py
+++ b/build/upload.py
@@ -104,10 +104,10 @@ def DoSSHCommand(command, user, host, port=None, ssh_key=None):
         try:
             output = f(cmdline, stderr=STDOUT).strip()
         except CalledProcessError as e:
-            print "failed ssh command output:"
-            print '=' * 20
-            print e.output
-            print '=' * 20
+            print("failed ssh command output:")
+            print('=' * 20)
+            print(e.output)
+            print('=' * 20)
             raise
         return output
 
@@ -118,7 +118,7 @@ def DoSCPFile(file, remote_path, user, host, port=None, ssh_key=None,
     """Upload file to user@host:remote_path using scp. Optionally use
     port and ssh_key, if provided."""
     if log:
-        print 'Uploading %s' % file
+        print('Uploading %s' % file)
     cmdline = ["scp"]
     AppendOptionalArgsToSSHCommandline(cmdline, port, ssh_key)
     cmdline.extend([WindowsPathToMsysPath(file),
@@ -221,7 +221,7 @@ def UploadFiles(user, host, path, files, verbose=False, port=None, ssh_key=None,
     if not host or not user:
         return {}
     if (not path and not upload_to_temp_dir) or (path and upload_to_temp_dir):
-        print "One (and only one of UPLOAD_PATH or UPLOAD_TO_TEMP must be " + \
+        print("One (and only one of UPLOAD_PATH or UPLOAD_TO_TEMP must be " + \)
                 "defined."
         sys.exit(1)
 
@@ -269,18 +269,18 @@ def UploadFiles(user, host, path, files, verbose=False, port=None, ssh_key=None,
 
         if post_upload_command is not None:
             if verbose:
-                print "Running post-upload command: " + post_upload_command
+                print("Running post-upload command: " + post_upload_command)
             file_list = '"' + '" "'.join(remote_files) + '"'
             output = DoSSHCommand('%s "%s" %s' % (post_upload_command, path, file_list), user, host, port=port, ssh_key=ssh_key)
             # We print since mozharness may parse URLs from the output stream.
-            print output
+            print(output)
             properties = GetUrlProperties(output, package)
     finally:
         if upload_to_temp_dir:
             DoSSHCommand("rm -rf %s" % path, user, host, port=port,
                          ssh_key=ssh_key)
     if verbose:
-        print "Upload complete"
+        print("Upload complete")
     return properties
 
 def CopyFilesLocally(path, files, verbose=False, base_path=None, package=None):
@@ -299,7 +299,7 @@ def CopyFilesLocally(path, files, verbose=False, base_path=None, package=None):
         if not os.path.exists(target_path):
             os.makedirs(target_path)
         if verbose:
-            print "Copying " + file + " to " + target_path
+            print("Copying " + file + " to " + target_path)
         shutil.copy(file, target_path)
 
 def WriteProperties(files, properties_file, url_properties, package):
@@ -341,20 +341,20 @@ if __name__ == '__main__':
                       help="Name of the main package.")
     (options, args) = parser.parse_args()
     if len(args) < 1:
-        print "You must specify at least one file to upload"
+        print("You must specify at least one file to upload")
         sys.exit(1)
     if not options.properties_file:
-        print "You must specify a --properties-file"
+        print("You must specify a --properties-file")
         sys.exit(1)
 
     if host == "localhost":
         if upload_to_temp_dir:
-            print "Cannot use UPLOAD_TO_TEMP with UPLOAD_HOST=localhost"
+            print("Cannot use UPLOAD_TO_TEMP with UPLOAD_HOST=localhost")
             sys.exit(1)
         if post_upload_command:
             # POST_UPLOAD_COMMAND is difficult to extract from the mozharness
             # scripts, so just ignore it until it's no longer used anywhere
-            print "Ignoring POST_UPLOAD_COMMAND with UPLOAD_HOST=localhost"
+            print("Ignoring POST_UPLOAD_COMMAND with UPLOAD_HOST=localhost")
 
     try:
         if host == "localhost":
@@ -371,5 +371,5 @@ if __name__ == '__main__':
 
             WriteProperties(args, options.properties_file, url_properties, options.package)
     except IOError, (strerror):
-        print strerror
+        print(strerror)
         sys.exit(1)
diff --git a/build/util/count_ctors.py b/build/util/count_ctors.py
index 6a3a870685..58e45dc78a 100644
--- a/build/util/count_ctors.py
+++ b/build/util/count_ctors.py
@@ -1,4 +1,3 @@
-
 #!/usr/bin/python
 import json
 import re
@@ -36,7 +35,7 @@ def count_ctors(filename):
         # Even if we have .ctors, we shouldn't have any constructors in .ctors.
         # Complain if .ctors does not look how we expect it to.
         if have_ctors and n_ctors_ctors != 0:
-            print >>sys.stderr, "Unexpected .ctors contents for", filename
+            print("Unexpected .ctors contents for", filename, file=sys.stderr)
             sys.exit(1)
         return n_init_array_ctors
     if have_ctors:
@@ -44,7 +43,7 @@ def count_ctors(filename):
 
     # We didn't find anything; somebody switched initialization mechanisms on
     # us, or the binary is completely busted.  Complain either way.
-    print >>sys.stderr, "Couldn't find .init_array or .ctors in", filename
+    print("Couldn't find .init_array or .ctors in", filename, file=sys.stderr)
     sys.exit(1)
 
 if __name__ == '__main__':
@@ -60,5 +59,5 @@ if __name__ == '__main__':
                 }]}
             ]
         }
-        print "PERFHERDER_DATA: %s" % json.dumps(perfherder_data)
+        print("PERFHERDER_DATA: %s" % json.dumps(perfherder_data))
 
diff --git a/build/util/hg.py b/build/util/hg.py
index c76c8ef033..5656a28055 100644
--- a/build/util/hg.py
+++ b/build/util/hg.py
@@ -2,8 +2,8 @@
 import os
 import re
 import subprocess
-from urlparse import urlsplit
-from ConfigParser import RawConfigParser
+from urllib.parse import urlsplit
+from configparser import RawConfigParser
 
 from util.commands import run_cmd, get_output, remove_path
 from util.retry import retry
@@ -34,7 +34,7 @@ def make_hg_url(hgHost, repoPath, protocol='https', revision=None,
                 filename=None):
     """construct a valid hg url from a base hg url (hg.mozilla.org),
     repoPath, revision and possible filename"""
-    base = '%s://%s' % (protocol, hgHost)
+    base = '{}://{}'.format(protocol, hgHost)
     repo = '/'.join(p.strip('/') for p in [base, repoPath])
     if not filename:
         if not revision:
@@ -88,7 +88,7 @@ def hg_ver():
     """Returns the current version of hg, as a tuple of
     (major, minor, build)"""
     ver_string = get_output(['hg', '-q', 'version'])
-    match = re.search("\(version ([0-9.]+)\)", ver_string)
+    match = re.search(r"\(version ([0-9.]+)\)", ver_string)
     if match:
         bits = match.group(1).split(".")
         if len(bits) < 3:
@@ -105,7 +105,7 @@ def purge(dest):
     try:
         run_cmd(['hg', '--config', 'extensions.purge=', 'purge',
                  '-a', '--all', dest], cwd=dest)
-    except subprocess.CalledProcessError, e:
+    except subprocess.CalledProcessError as e:
         log.debug('purge failed: %s' % e)
         raise
 
@@ -306,7 +306,7 @@ def out(src, remote, **kwargs):
                     branch = "default"
                 revs.append((rev, branch))
             return revs
-        except subprocess.CalledProcessError, inst:
+        except subprocess.CalledProcessError as inst:
             # In some situations, some versions of Mercurial return "1"
             # if no changes are found, so we need to ignore this return code
             if inst.returncode == 1:
@@ -500,7 +500,7 @@ def apply_and_push(localrepo, remote, changer, max_attempts=10,
             push(src=localrepo, remote=remote, ssh_username=ssh_username,
                  ssh_key=ssh_key, force=force)
             return
-        except subprocess.CalledProcessError, e:
+        except subprocess.CalledProcessError as e:
             log.debug("Hit error when trying to push: %s" % str(e))
             if n == max_attempts:
                 log.debug("Tried %d times, giving up" % max_attempts)
@@ -515,7 +515,7 @@ def apply_and_push(localrepo, remote, changer, max_attempts=10,
             try:
                 run_cmd(['hg', '--config', 'ui.merge=internal:merge',
                          'rebase'], cwd=localrepo)
-            except subprocess.CalledProcessError, e:
+            except subprocess.CalledProcessError as e:
                 log.debug("Failed to rebase: %s" % str(e))
                 update(localrepo, branch=branch)
                 for r in reversed(new_revs):
